package listFW.visitor;

import listFW.*;

/**
 * Counts all elements in an IList of IList.
 * @author sw
 */
public class CountAll_TailRec3 implements IListAlgo {
  public static final CountAll_TailRec3 Singleton = new CountAll_TailRec3();
  private CountAll_TailRec3() {
  }
  
  public Object emptyCase(IMTList host, Object nu) {
    return new Integer(0);
  }
  
  public Object nonEmptyCase(INEList host, Object nu) {
    return ((IList)host.getFirst()).execute(makeFirstHelper(host), new Integer(0));
  }
  
  private static final IListAlgo makeFirstHelper(final INEList host) {
    return new IListAlgo() {
      public Object emptyCase(IMTList hostFirst, Object acc) {
        return host.getRest().execute(Helper, acc);
      }
      public Object nonEmptyCase(INEList hostFirst, Object acc) {
        return hostFirst.getRest().execute(this, new Integer(1 + ((Integer)acc).intValue()));
      }  
    }; 
  }
  
  private static final IListAlgo Helper = new IListAlgo() { 
    public Object emptyCase(IMTList host, Object acc) {
      return acc;
    }
    public Object nonEmptyCase(INEList host, Object acc) {
      return ((IList)host.getFirst()).execute(makeFirstHelper(host), acc); 
    }
  };
}