package listFW.visitor;

import listFW.*;

/**
 * Counts all elements in an IList of IList.
 * @author sw
 */
public class CountAll_TailRec4 implements IListAlgo {
  public static final CountAll_TailRec4 Singleton = new CountAll_TailRec4();
  private CountAll_TailRec4() {
  }
  
  public Object emptyCase(IMTList host, Object nu) {
    return new Integer(0);
  }
  
  public Object nonEmptyCase(INEList host, Object nu) {
    return host.execute(new IListAlgo() {
      public Object emptyCase(IMTList hostOuter, Object accOuter) {
        return accOuter;
      }
      public Object nonEmptyCase(INEList hostOuter, Object accOuter) {
        // add the count of first to the accumulator
        Object newAcc = ((IList)hostOuter.getFirst()).execute(new IListAlgo() {
          public Object emptyCase(IMTList hostInner, Object accInner) {
            return accInner;
          }
          public Object nonEmptyCase(INEList hostInner, Object accInner) {
            // recur on rest of inner list
            return hostInner.getRest().execute(this, addOne(accInner));
          }
        }, accOuter);
        // recur on rest of outer list.
        return hostOuter.getRest().execute(this, newAcc);      
      }
    }, new Integer(0));    // start fwd accumulation up on outer host
  }
  
  /**
   * Utility method to add 1 to an Object that is an Integer
   * @param i An Integer object
   * @return An Integer object one more than the input i
   */
  private static final Integer addOne(Object i) {
    return new Integer(1+((Integer)i).intValue());
  }
}